<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <script src="{basePath}/svg-inject.min.js"></script>
    <script src="{basePath}/jquery-3.5.1.min.js"></script>
    <link rel="stylesheet" href="{basePath}/common.css">
    <link rel="stylesheet" href="{basePath}/registerViewDark.css">
    <link rel="stylesheet" href="{basePath}/bootstrap-4.5.2-dist/css/bootstrap.css">
</head>
  
<body>
    <p id="demo"></p>
    <div class="loadingContainer">
        <img src="{basePath}/../../resources/dark/loading.svg" style="stroke: white;" onload="SVGInject(this)" />
    </div>
    <div class="container-fluid">
        <div class="row" id="div1">
        </div>
    </div>
    <script>
        window.addEventListener('message', event => {
            const message = event.data;
            switch (message.type) {
                case 'stopLoading':
                    $('.loadingContainer').css('display', 'none');
                    break;
                case 'update':
                    parser = new DOMParser();
                    xmlDoc = parser.parseFromString(message.xml, "text/xml");           
                    let registersNode = xmlDoc.getElementsByTagName("registers")[0];
                    for (let x = 0; x < registersNode.childNodes.length; x++) {
                        let node = registersNode.childNodes[x];
                        if (node.nodeType == Node.ELEMENT_NODE) {
                            console.log(node.nodeName + '=' + node.firstChild.nodeValue);
                            if ($('#' + node.nodeName).val() == node.firstChild.nodeValue) {
                                $('#' + node.nodeName).removeClass('highlight');
                            } else {
                                $('#' + node.nodeName).addClass('highlight');
                            }
                            $('#' + node.nodeName).val(node.firstChild.nodeValue);
                        }
                    }
                    break;
            }
        });
    </script>
    <script>
        const vscode = acquireVsCodeApi();

        function getRegister() {
            vscode.postMessage({
                command: 'getRegister',
                text: 'nothing'
            });
        }

        registers = ['pc', 'ra', 'sp', 'gp', 'tp', 'fp', 'zero', 't0', 't1', 't2', 't3', 't4', 't5', 't6', 'a0', 'a1', 'a2', 'a3', 'a4', 'a5', 'a6', 'a7', 's0', 's1', 's2', 's3', 's4', 's5', 's6', 's7', 's8', 's9', 's10', 's11', 'x0',
            'x1', 'x2', 'x3', 'x4', 'x5', 'x6', 'x7', 'x8', 'x9', 'x10', 'x11', 'x12', 'x13', 'x14', 'x15', 'x16', 'x17', 'x18', 'x19', 'x20', 'x21', 'x22', 'x23', 'x24', 'x25', 'x26', 'x27', 'x28', 'x29', 'x30', 'x31'];
        csr = ['mstatus', 'misa', 'mvendorid', 'marchid', 'mimpid', 'priv'];
        for (x = 0; x < registers.length; x++) {
            $('#div1').html($('#div1').html() + `
			<div class="col-md-3 col-sm-4 col-6">
				<div class="input-group mb-1">
					<div class="input-group-prepend" style="height: 25px;">
						<div class="input-group-text" >` + registers[x] + `</div>
					</div>
					<input id = ` + registers[x] + ` class="form-control" value="0x00000000" style="height: 25px;"/>
				</div>
			</div>
			`);
        }

        for (x = 0; x < csr.length; x++) {
            $('#div1').html($('#div1').html() + `
			<div id ="csr" class="col-md-3 col-sm-4 col-6">
				<div class="input-group mb-1">
					<div class="input-group-prepend" style="height: 25px; ">
						<div class="input-group-text" style="width: 75px;">` + csr[x] + `</div>
					</div>
					<input id = ` + csr[x] + ` class="form-control" style="height: 25px;"/>
				</div>
			</div>
			`);
        }
    </script>
</body>

</html>